package errors

import org.scalatest._
import testutil.PendingIfUnimplemented

class EitherSpec extends FlatSpec with Matchers with AppendedClues with PendingIfUnimplemented {
  val l1: Either[Int, Int] = Left(1)
  val l2: Either[Int, Int] = Left(2)
  val r1: Either[Int, Int] = Right(1)
  val r2: Either[Int, Int] = Right(2)

  "Either" should "have a map2 method which correctly combines two values" in {
    l1.map2(r1)((a, b) => a+b) shouldBe l1
    r1.map2(l1)((a, b) => a+b) shouldBe l1
    r1.map2(r1)((a, b) => a+b) shouldBe r2
    l1.map2(l2)((a, b) => a+b) shouldBe l1
  }
}

