package testutil

import org.scalatest._

/**
  * Mix into a test suite to mark tests for ??? methods as "pending" instead of "failed"
  */
trait PendingIfUnimplemented extends TestSuiteMixin { this: TestSuite =>
  abstract override def withFixture(test: NoArgTest): Outcome = {
    super.withFixture(test) match {
      case Failed(_: NotImplementedError) => Pending
      case other => other
    }
  }
}
